// 2009 ReVoL Primer Template
// opengl.h
#pragma once
#include "targetver.h"
#include <windows.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <math.h>
#include <assert.h>
#include "resource.h"

//   OpenGL
void OGLDraw1(HWND hWnd) {
}

//   OpenGL
void OGLDraw2(HWND hWnd) {
}

//   OpenGL
void OGLDraw3(HWND hWnd) {
}

//   OpenGL
void OGLDraw4(HWND hWnd) {
}

//  OpenGL
void OGLInit(HWND hWnd) {
    HDC hdc;
    HGLRC hglrc;
    PIXELFORMATDESCRIPTOR pfd;
    int iPixelFormat;
    memset(&pfd, 0, sizeof(PIXELFORMATDESCRIPTOR));
    pfd.nSize = sizeof(PIXELFORMATDESCRIPTOR);
    pfd.nVersion = 1;
    pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL;
    pfd.iPixelType = PFD_TYPE_RGBA;
    pfd.cColorBits = 24;
    pfd.cDepthBits = 32;
    pfd.iLayerType = PFD_MAIN_PLANE;
    //    OpenGL (hglrc)
    //     (hdc)
    hdc = GetDC(hWnd);
    iPixelFormat = ChoosePixelFormat(hdc, &pfd);
    SetPixelFormat(hdc, iPixelFormat, &pfd);
    hglrc = wglCreateContext(hdc);
    if (hglrc) wglMakeCurrent(hdc, hglrc);
}

//  OpenGL
void OGLClose(HWND hWnd) {
    HDC hdc;
    HGLRC hglrc;
    hglrc = wglGetCurrentContext();
    if (hglrc) {
        hdc = wglGetCurrentDC();
        wglMakeCurrent(0, 0);
        ReleaseDC(hWnd, hdc);
        wglDeleteContext(hglrc);
    }
}

//    
void OGLResize(HWND hWnd) {
    RECT rc;
    GetClientRect(hWnd, &rc);
    glViewport(0, 0, rc.right, rc.bottom);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
}
